searchNodes=[{"doc":"Provides a set of helpers to work with Changesets.","ref":"ChangesetHelpers.html","title":"ChangesetHelpers","type":"module"},{"doc":"Adds an error to the nested changeset.account_changeset = ChangesetHelpers.add_error(account_changeset, [:user, :articles, :error_key], &quot;Some error&quot;)","ref":"ChangesetHelpers.html#add_error/4","title":"ChangesetHelpers.add_error/4","type":"function"},{"doc":"","ref":"ChangesetHelpers.html#change_assoc/2","title":"ChangesetHelpers.change_assoc/2","type":"function"},{"doc":"Returns the nested association in a changeset. This function will first look into the changes and then fails back on data wrapped in a changeset.Changes may be added to the given changeset through the third argument.A tuple is returned containing the root changeset, and the changeset of the association.{account_changeset, address_changeset} = change_assoc(account_changeset, [:user, :config, :address], %{street: &quot;Foo street&quot;})","ref":"ChangesetHelpers.html#change_assoc/3","title":"ChangesetHelpers.change_assoc/3","type":"function"},{"doc":"Returns the nested association in a changeset at the given index.A tuple is returned containing the root changeset, the changesets of the association and the changeset at the specified index.See change_assoc(struct_or_changeset, keys, changes).","ref":"ChangesetHelpers.html#change_assoc/4","title":"ChangesetHelpers.change_assoc/4","type":"function"},{"doc":"This function allows checking if a given field is different between two changesets.{street_changed, street1, street2} = diff_field(account_changeset, new_account_changeset, [:user, :config, :address, :street])","ref":"ChangesetHelpers.html#diff_field/3","title":"ChangesetHelpers.diff_field/3","type":"function"},{"doc":"","ref":"ChangesetHelpers.html#do_raise_if_invalid_fields/2","title":"ChangesetHelpers.do_raise_if_invalid_fields/2","type":"function"},{"doc":"Fetches a nested change from the given changeset.This function only looks at the :changes field of the given changeset and returns {:ok, value} if the change is present or :error if it's not.{:ok, street} = ChangesetHelpers.fetch_change(account_changeset, [:user, :config, :address, :street])","ref":"ChangesetHelpers.html#fetch_change/2","title":"ChangesetHelpers.fetch_change/2","type":"function"},{"doc":"Same as fetch_change/2 but returns the value or raises if the given nested key was not found.street = ChangesetHelpers.fetch_change!(account_changeset, [:user, :config, :address, :street])","ref":"ChangesetHelpers.html#fetch_change!/2","title":"ChangesetHelpers.fetch_change!/2","type":"function"},{"doc":"Fetches the given nested field from changes or from the data.While fetch_change/2 only looks at the current changes to retrieve a value, this function looks at the changes and then falls back on the data, finally returning :error if no value is available.For relations, these functions will return the changeset original data with changes applied. To retrieve raw changesets, please use fetch_change/2.{:changes, street} = ChangesetHelpers.fetch_field(account_changeset, [:user, :config, :address, :street])","ref":"ChangesetHelpers.html#fetch_field/2","title":"ChangesetHelpers.fetch_field/2","type":"function"},{"doc":"Same as fetch_field/2 but returns the value or raises if the given nested key was not found.street = ChangesetHelpers.fetch_field!(account_changeset, [:user, :config, :address, :street])","ref":"ChangesetHelpers.html#fetch_field!/2","title":"ChangesetHelpers.fetch_field!/2","type":"function"},{"doc":"Puts the given nested association in the changeset through a given list of field names.ChangesetHelpers.put_assoc(account_changeset, [:user, :config, :address], address_changeset)Instead of giving a Changeset or a schema as the third argument, a function may also be given receiving the nested Changeset(s) to be updated as argument.ChangesetHelpers.put_assoc(account_changeset, [:user, :articles], &amp;(Enum.concat(&amp;1, [%Article{} |&gt; Ecto.Changeset.change()])))In the code above, we add a new empty Article to the articles association (typically done when we want to add a new article to a form).","ref":"ChangesetHelpers.html#put_assoc/3","title":"ChangesetHelpers.put_assoc/3","type":"function"},{"doc":"Puts the given nested association in the changeset at the given index.See put_assoc(changeset, keys, value).","ref":"ChangesetHelpers.html#put_assoc/4","title":"ChangesetHelpers.put_assoc/4","type":"function"},{"doc":"Raises if one of the given field has an invalid value.","ref":"ChangesetHelpers.html#raise_if_invalid_fields/2","title":"ChangesetHelpers.raise_if_invalid_fields/2","type":"function"},{"doc":"ChangesetHelpersThis library provides a set of helper functions to work with Ecto Changesets.raise_if_invalid_fields(changeset, keys)Raises if one of the given field has an invalid value.changeset |&gt; validate_inclusion(:cardinal_direction, [&quot;north&quot;, &quot;east&quot;, &quot;south&quot;, &quot;west&quot;]) |&gt; raise_if_invalid_fields([:cardinal_direction])put_assoc(changeset, keys, value)Puts the given nested association in the changeset through a given list of field names.ChangesetHelpers.put_assoc(account_changeset, [:user, :config, :address], address_changeset)Instead of giving a Changeset or a schema as the third argument, a function may also be given in order to modify the nested changeset in one go.ChangesetHelpers.put_assoc(account_changeset, [:user, :articles], &amp;(Enum.concat(&amp;1, [%Article{} |&gt; Ecto.Changeset.change()])))In the code above, we change a new empty Article, and add the changeset into the articles association (typically done when we want to add a new row of form inputs to add an entity into a form handling a nested collection of entities).put_assoc(changeset, keys, index, value)Puts the given nested association in the changeset through a given list of field names, at the given index.change_assoc(struct_or_changeset, keys, changes \\\\ %{})Returns the nested association in a changeset. This function will first look into the changes and then fails back on data wrapped in a changeset.Changes may be added to the given changeset through the third argument.A tuple is returned containing the modified root changeset and the changeset of the association.{account_changeset, address_changeset} = change_assoc(account_changeset, [:user, :user_config, :address], %{street: &quot;Foo street&quot;})change_assoc(struct_or_changeset, keys, index, changes \\\\ %{})Returns the nested association in a changeset at the given index.fetch_field(changeset, keys)Fetches the given nested field from changes or from the data.{:changes, street} = ChangesetHelpers.fetch_field(account_changeset, [:user, :config, :address, :street])fetch_field!(changeset, keys)Same as fetch_field/2 but returns the value or raises if the given nested key was not found.street = ChangesetHelpers.fetch_field!(account_changeset, [:user, :config, :address, :street])fetch_change(changeset, keys)Fetches the given nested field from changes or from the data.{:ok, street} = ChangesetHelpers.fetch_change(account_changeset, [:user, :config, :address, :street])fetch_change!(changeset, keys)Same as fetch_change/2 but returns the value or raises if the given nested key was not found.street = ChangesetHelpers.fetch_change!(account_changeset, [:user, :config, :address, :street])diff_field(changeset1, changeset2, keys)This function allows checking if a given field is different in two changesets.{street_changed, street1, street2} = diff_field(account_changeset, new_account_changeset, [:user, :user_config, :address, :street])add_error(changeset, keys, message, extra \\\\ [])Adds an error to the nested changeset.ChangesetHelpers.add_error(account_changeset, [:user, :articles, :error_key], &quot;Some error&quot;)","ref":"readme.html","title":"ChangesetHelpers","type":"extras"},{"doc":"Add changeset_helpers for Elixir as a dependency in your mix.exs file:def deps do [ {:changeset_helpers, &quot;~&gt; 0.9.0&quot;} ] end","ref":"readme.html#installation","title":"ChangesetHelpers - Installation","type":"extras"},{"doc":"HexDocs documentation can be found at https://hexdocs.pm/changeset_helpers.","ref":"readme.html#hexdocs","title":"ChangesetHelpers - HexDocs","type":"extras"}]